
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class TeamsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const teams = await db.teams.create(
            {
                id: data.id || undefined,
        
        team_name: data.team_name
        ||
        null
            ,
            
        team_code: data.team_code
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await teams.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await teams.setManager( data.manager || null, {
            transaction,
        });
        

        

        

        return teams;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const teamsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                team_name: item.team_name
            ||
            null
            ,
            
                team_code: item.team_code
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const teams = await db.teams.bulkCreate(teamsData, { transaction });

        // For each item created, replace relation files
        

        return teams;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const teams = await db.teams.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.team_name !== undefined) updatePayload.team_name = data.team_name;
        
        
        if (data.team_code !== undefined) updatePayload.team_code = data.team_code;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await teams.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await teams.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.manager !== undefined) {
            await teams.setManager(
              
              data.manager,
              
              { transaction }
            );
        }
        

        
        

        

        return teams;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const teams = await db.teams.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of teams) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of teams) {
                await record.destroy({transaction});
            }
        });


        return teams;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const teams = await db.teams.findByPk(id, options);

        await teams.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await teams.destroy({
            transaction
        });

        return teams;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const teams = await db.teams.findOne(
            { where },
            { transaction },
        );

        if (!teams) {
            return teams;
        }

        const output = teams.get({plain: true});

        
        
        
        
        
        
        
        
        output.team_memberships_team = await teams.getTeam_memberships_team({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.challenge_participants_team = await teams.getChallenge_participants_team({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await teams.getOrganization({
            transaction
        });
        
        
        output.manager = await teams.getManager({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.users,
        as: 'manager',
        
        where: filter.manager ? {
          [Op.or]: [
            { id: { [Op.in]: filter.manager.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.manager.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.team_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'teams',
                        'team_name',
                        filter.team_name,
                    ),
                };
            }
            
            if (filter.team_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'teams',
                        'team_code',
                        filter.team_code,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'teams',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.teams.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'teams',
                        'team_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.teams.findAll({
            attributes: [ 'id', 'team_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['team_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.team_name,
        }));
    }

    
};

